// 002 u_display_refcount
// 15 sep 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)
unit u_display_refcount;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    display_: TTabSheet;
    memo_: TTabSheet;
    Panel2: TPanel;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    memo_panel_: TPanel;
    Splitter1: TSplitter;
    affectation_: TButton;
    reassign_i_printer_: TButton;
    check_object_: TButton;
    dec_call_: TButton;
    call_addref_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure close_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure affectation_Click(Sender: TObject);
    procedure reassign_i_printer_Click(Sender: TObject);
    procedure check_object_Click(Sender: TObject);
    procedure dec_call_Click(Sender: TObject);
    procedure call_addref_Click(Sender: TObject);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses u_c_log, u_c_display

       ;

    {$R *.DFM}

    // -- tForm1

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.close_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- interfaces

    type i_printer=
              Interface
                ['{D7268B1E-3465-4AA7-B62E-F3BD3856B5C0}']
                procedure print;
              end; // i_printer

         c_letter=
              Class(tInterfacedObject, i_printer)
                m_line_count: Integer;
                procedure insert_line;
                procedure print;
              end; // c_letter

    procedure c_letter.insert_line;
      begin
        display('insert_line');
      end; // insert_line

    procedure c_letter.print;
      begin
        display('print');
      end; // print



    var g_c_letter: c_letter= Nil;

    procedure display_letter_refcount(p_text: String);
      begin
        display(p_text+ ' RefCount= '+ IntToStr(g_c_letter.RefCount)); // + Format(' %p', [Pointer(g_c_letter)]));
      end; // display_letter_refcount

    procedure format_printout(p_i_printer: i_printer);
      begin
        display_letter_refcount('in_method');
        p_i_printer.print;
      end; // format_printout

    procedure TForm1.affectation_Click(Sender: TObject);
      var l_i_printer: i_printer;
      begin
        g_c_letter:= c_letter.Create;
        display_letter_refcount('1_after_create');

        // -- affactation (compatibilit en affectation)
        l_i_printer:= g_c_letter;
        display_letter_refcount('2_after_i_assign');

        // -- appel d'une mthode de l'Interface i_printer
        l_i_printer.print;
        // -- appel d'une procdure ayant un paramtre i_printer
        format_printout(l_i_printer);
        display_letter_refcount('3_after_method_1');

        // -- appel, avec compatibilit en affactation
        format_printout(g_c_letter);
        display_letter_refcount('4_after_method_2');
      end; // affectation_Click

    procedure TForm1.reassign_i_printer_Click(Sender: TObject);
      var l_i_printer: i_printer;
      begin
        g_c_letter:= c_letter.Create;
        display_letter_refcount('1_after_create');

        // -- affactation (compatibilit en affectation)
        l_i_printer:= g_c_letter;
        display_letter_refcount('2_after_i_assign');

        l_i_printer:= c_letter.Create;
        display_letter_refcount('2_after_i_assign');
      end; // reassign_i_printer_Click

    procedure TForm1.call_addref_Click(Sender: TObject);
      var l_i_printer: i_printer;
      begin
        g_c_letter:= c_letter.Create;
        display_letter_refcount('1_after_create');

        l_i_printer:= g_c_letter;
        display_letter_refcount('2_after_i_assign');

        // -- affactation (compatibilit en affectation)
        iInterface(l_i_printer)._AddRef;
        display_letter_refcount('3_after_AddRef');

        l_i_printer:= c_letter.Create;
        display_letter_refcount('4_after_reassign');
      end; // call_addref_Click

    procedure TForm1.check_object_Click(Sender: TObject);
      begin
        display_line;
        display_letter_refcount('5_global_click');
        g_c_letter.insert_line;
        g_c_letter.m_line_count:= 5;
        if g_c_letter is c_letter
          then display('ok');
      end; // check_object_Click

    // -- another trial

    procedure format_and_dec(p_i_printer: i_printer);
      begin
        display_letter_refcount('in_method_after_begin');
        p_i_printer.print;
        // -- reassign
        p_i_printer:= Nil;
        display_letter_refcount('in_method_before_end');
      end; // format_and_dec

    procedure TForm1.dec_call_Click(Sender: TObject);
      var l_i_printer: i_printer;
      begin
        g_c_letter:= c_letter.Create;
        display_letter_refcount('1_after_create');

        // -- affactation (compatibilit en affectation)
        l_i_printer:= g_c_letter;
        display_letter_refcount('2_after_i_assign');

        format_and_dec(l_i_printer);
        display_letter_refcount('3_after_format_and_dec');
      end;

end.


